//---------------------------------------------------------------------------

#ifndef CChartToolsH
#define CChartToolsH
//---------------------------------------------------------------------------
#include "Chart.hpp"

class CBasicChartManager;

class CChartTools
{
	int iDefaultMargLeft;
	int iDefaultMargRight;
	int iDefaultMargBottom;
	int iDefaultMargTop;
	int iDefaultLegendMargin;
	int iDefaultTitleMargin;
	int iDefaultVerticalExtraPos;
	int iDefaultHorizontalExtraPos;

	bool bVerticalAxisInOneStack;
	bool bHorizontalAxisInOneStack;

	public:
	CChartTools();

	//Vertical
	int PlaceVerticalAxes(TCustomChart* Chart, int& NextXLeft, int& NextXRight, int& MargLeft, int& MargRight);
	bool PlaceVerticalAxes(TCustomChart* Chart, TChartAxis* pTCustomAxes, int& NextXLeft, int& NextXRight, int& MargLeft, int& MargRight);
	void StandardVerticalAxes(TCustomChart* Chart, TChartAxis* pTCustomAxes, int& NextXLeft, int& NextXRight, int& MargLeft, int& MargRight);

	int PlaceLeftVerticalAxesOnStack(TCustomChart* Chart, int& NextXLeft, int& NextXRight, int& MargLeft, int& MargRight);
	int PlaceRightVerticalAxesOnStack(TCustomChart* Chart, int& NextXLeft, int& NextXRight, int& MargLeft, int& MargRight);

	//Horizontal
	int PlaceHorizontalAxes(TCustomChart* Chart, int& NextXBottom, int& NextXTop, int& MargBottom, int& MargTop);
	bool PlaceHorizontalAxes(TCustomChart* Chart, TChartAxis* pTCustomAxes, int& NextXBottom, int& NextXTop, int& MargBottom, int& MargTop);
	void StandardHorizontalAxes(TCustomChart* Chart, TChartAxis* pTCustomAxes, int& NextXBottom, int& NextXTop, int& MargBottom, int& MargTop);

	int PlaceTopHorizontalAxesOnStack(TCustomChart* Chart, int& NextXBottom, int& NextXTop, int& MargBottom, int& MargTop);
	int PlaceBottomHorizontalAxesOnStack(TCustomChart* Chart, int& NextXBottom, int& NextXTop, int& MargBottom, int& MargTop);

	///Oblicz ilo wywietlanych osi poziomych grnych - dodatkowych
	int CountHorizontalTopCustomAxisDisplayed(TCustomChart* Chart);
	///Oblicz ilo wywietlanych osi poziomych dolnych - dodatkowych
	int CountHorizontalBottomCustomAxisDisplayed(TCustomChart* Chart);

	///Oblicz ilo wywietlanych osi pionowych lewych - dodatkowych
	int CountVerticalLeftCustomAxisDisplayed(TCustomChart* Chart);
	///Oblicz ilo wywietlanych osi pionowych prawych - dodatkowych
	int CountVerticalRightCustomAxisDisplayed(TCustomChart* Chart);

	///Oblicz ilo eszystkich wywietlanych osi dodatkowych
	int CountAllCustomAxisDisplayed(TCustomChart* Chart);

	///Oblicza rozmiar etykiety na osi
	int CalcAxisLabelSize(TChartAxis* pTCustomAxes);

	///Szeroko osi pionowej
	int CalcVerticalAxisWidth(TChartAxis* pTCustomAxes);
	///Wysoko osi poziomej
	int CalcHorizontalAxisHeight(TChartAxis* pTCustomAxes);

	///Sprawdzenie czy o jest wywietlana
	bool IsAxisVisible(TCustomChart* Chart, TChartAxis* pTCustomAxes);
	///Sprawdzenie czy legenda jest wywietlana
	bool IsLegendVisible(TChartLegend* Legend);

	//Znajd pierwsz aktywn serie dla wskazanej osi
	TChartSeries* FindFirstActiveSeriesForAxis(TCustomChart* Chart, TChartAxis* pTCustomAxes);
	//Znajd pierwsz wywietlan osi
	TChartAxis* FindFirstVisibleAxis(TCustomChart* Chart, bool bHorizontal);

	//Pozycjonowanie objektw wukresu
	void PlaceChartObjects(TCustomChart* Chart);

	///Ukrywanie obrysu supka w przypadku zbyt wskich supkw
	bool CalcBarPenVisibility(TCustomChart* pTChart);
    ///Przygotowanie ustawie osi
	void PrepareChartAxis(TChartAxis* pTChartAxis);
	///Ustawienie koloru osi np. koloru serii
	void PrepareChartAxisColor(TChartAxis* pTChartAxis);

	///Sprawdza czy o jest dodakowa
	bool IsCustomAxis(TChartAxis* pTChartAxis);
	///Ustawi widzilnoc osi na podstawie aktywnoci serii
	void PrepareAxisVisibility(TCustomChart* pTChart);

	int getDefaultMargLeft();
	int getDefaultMargRight();
	int getDefaultMargBottom();
	int getDefaultMargTop();

	bool getVerticalAxisInOneStack();
	void setVerticalAxisInOneStack(bool);
	bool getHorizontalAxisInOneStack();
	void setHorizontalAxisInOneStack(bool);
	///
	void CustomHorizontalAxisZoom(TChartAxis* pTCustomHorizontalAxes);
	///
	void CustomVerticalAxisZoom(TChartAxis* pTCustomVerticalAxes);
	///
	void CustomAxisZoom(TCustomChart* Chart);
	void CustomAxisUndoZoom(TCustomChart* Chart, bool bAutomatic);
};
#endif
