//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include <cmath>
#include "TfoMeta.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Chart"
#pragma link "TeeEdit"
#pragma link "TeeGDIPlus"
#pragma link "TeEngine"
#pragma link "TeeProcs"
#pragma link "TeeTools"
#pragma link "TeeLegendScrollBar"
#pragma link "TeeScrollPagerTool"
#pragma link "Series"
#pragma link "TeeChartGrid"
#pragma link "TeeComma"
#pragma link "TeeData"
#pragma link "TeeEdiGene"
#pragma link "TeeEdit"
#pragma link "TeeGDIPlus"
#pragma link "TeeImport"
#pragma link "TeeLisB"
#pragma link "TeeNavigator"
#pragma link "TeEngine"
#pragma link "TeeOpenGL"
#pragma link "TeeProcs"
#pragma link "TeeScroB"
#pragma link "TeeTools"
#pragma link "TeeURL"
#pragma link "TeeXML"

#pragma link "TeeJPEG"//Eksport JPEG
#pragma link "TeePNG"//Eksport PNG
#pragma link "TeeGIF"//Eksport GIF
#pragma link "TeePCX"//Eksport PCX

#pragma link "TeePDFCanvas"//Eksport PDF
#pragma link "TeePSCanvas"//Eksport PS
#pragma link "TeeSVGCanvas"//Eksport SVG

#pragma link "TeeHTML5Canvas"//Eksport HTML5
#pragma link "TeeJavaScript"//Eksport JS
#pragma link "TeeFlexCanvas"//Eksport Flex

#pragma link "TeeVMLCanvas"//Eksport VML
#pragma link "TeeVRML3D"//Eksport VRML3D
#pragma link "TeeXAMLCanvas"//Eksport XAML

#pragma link "TeeImport"
#pragma link "TeeExcelSource"
#pragma link "TeeSeriesTextEd"
#pragma link "TeeSubChart"
#pragma link "TeeLisB"
#pragma resource "*.dfm"
TfoCustomAxis* foCustomAxis;

//---------------------------------------------------------------------------
__fastcall TfoCustomAxis::TfoCustomAxis(TComponent* Owner) : TForm(Owner), pCChartTools(NULL)
{
    bFirstDraw = true;
	pCChartTools = new CChartTools();
	pCChartTools->setVerticalAxisInOneStack(cbVerticalAxisInOneStack->Checked);
	pCChartTools->setHorizontalAxisInOneStack(cbHorizontalAxisInOneStack->Checked);
}
//---------------------------------------------------------------------------
__fastcall TfoCustomAxis::~TfoCustomAxis()
{
	if(pCChartTools)
	{
		delete pCChartTools;
		pCChartTools = NULL;
    }
}
//---------------------------------------------------------------------------
void TfoCustomAxis::AddVerticalSeries(int i, bool bOtherSide)
{
	TChartSeries* pTChartSeries = Chart1->AddSeries(new TLineSeries(Chart1));
	if(pTChartSeries)
	{
		dynamic_cast<TLineSeries*>(pTChartSeries)->Stairs = true;
		pTChartSeries->Title = "Series" + IntToStr(i);
		TChartAxis* pTChartAxis = Chart1->CustomAxes->Add();
		if(pTChartAxis)
		{
			Chart1->Series[i]->CustomVertAxis = pTChartAxis;
			pTChartAxis->OtherSide = bOtherSide;
			pCChartTools->PrepareChartAxis(pTChartAxis);
		}
		ComboBoxSeries->Items->Add(pTChartSeries->Title);
		pTChartSeries->FillSampleValues(StrToInt(ComboBoxSamples->Text));
	}
}
//---------------------------------------------------------------------------
void TfoCustomAxis::AddAllCustomAxisSeries(int i, bool bOtherSide)
{
	TChartSeries* pTChartSeries = Chart1->AddSeries(new TLineSeries(Chart1));
	if(pTChartSeries)
	{
		dynamic_cast<TLineSeries*>(pTChartSeries)->Stairs = true;
		pTChartSeries->Title = "Series" + IntToStr(i);

		TChartAxis* pTChartAxisVert = Chart1->CustomAxes->Add();
		if(pTChartAxisVert)
		{
			Chart1->Series[i]->CustomVertAxis = pTChartAxisVert;
			pTChartAxisVert->OtherSide = bOtherSide;
			pCChartTools->PrepareChartAxis(pTChartAxisVert);
		}

		TChartAxis* pTChartAxisHoriz = Chart1->CustomAxes->Add();
		if(pTChartAxisHoriz)
		{
            pTChartAxisHoriz->Horizontal = true;
			Chart1->Series[i]->CustomHorizAxis = pTChartAxisHoriz;
			pTChartAxisHoriz->OtherSide = bOtherSide;
			pCChartTools->PrepareChartAxis(pTChartAxisHoriz);
		}

		ComboBoxSeries->Items->Add(pTChartSeries->Title);
		pTChartSeries->FillSampleValues(StrToInt(ComboBoxSamples->Text));
	}
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::bAddLeftSeriesClick(TObject *Sender)
{
	TChartSeries* pTChartSeries = Chart1->AddSeries(new TLineSeries(Chart1));
	if(pTChartSeries)
	{
		dynamic_cast<TLineSeries*>(pTChartSeries)->Stairs = true;

		pTChartSeries->Title = "Series" + IntToStr(Chart1->SeriesCount() - 1);

		pTChartSeries->VertAxis = aLeftAxis;
		Chart1->LeftAxis->Title->Caption = pTChartSeries->Title;
		Chart1->LeftAxis->Grid->Visible = False;

		ComboBoxSeries->Items->Add(pTChartSeries->Title);
		pTChartSeries->FillSampleValues(StrToInt(ComboBoxSamples->Text));
	}
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::bAddRightSeriesClick(TObject *Sender)
{
	TChartSeries* pTChartSeries = Chart1->AddSeries(new TLineSeries(Chart1));
	if(pTChartSeries)
	{
		dynamic_cast<TLineSeries*>(pTChartSeries)->Stairs = true;

		pTChartSeries->Title = "Series" + IntToStr(Chart1->SeriesCount() - 1);

		pTChartSeries->VertAxis = aRightAxis;
		Chart1->RightAxis->Title->Caption = pTChartSeries->Title;
		Chart1->RightAxis->Grid->Visible = False;

		ComboBoxSeries->Items->Add(pTChartSeries->Title);
		pTChartSeries->FillSampleValues(StrToInt(ComboBoxSamples->Text));
	}
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::bAddTopSeriesClick(TObject *Sender)
{
	TChartSeries* pTChartSeries = Chart1->AddSeries(new TLineSeries(Chart1));
	if(pTChartSeries)
	{
		dynamic_cast<TLineSeries*>(pTChartSeries)->Stairs = true;

		pTChartSeries->Title = "Series" + IntToStr(Chart1->SeriesCount() - 1);

		pTChartSeries->HorizAxis = aTopAxis;
		Chart1->TopAxis->Title->Caption = pTChartSeries->Title;
		Chart1->TopAxis->Grid->Visible = False;

		ComboBoxSeries->Items->Add(pTChartSeries->Title);
		pTChartSeries->FillSampleValues(StrToInt(ComboBoxSamples->Text));
	}
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::bAddBottomSeriesClick(TObject *Sender)
{
	TChartSeries* pTChartSeries = Chart1->AddSeries(new TLineSeries(Chart1));
	if(pTChartSeries)
	{
		dynamic_cast<TLineSeries*>(pTChartSeries)->Stairs = true;

		pTChartSeries->Title = "Series" + IntToStr(Chart1->SeriesCount() - 1);

		pTChartSeries->HorizAxis = aBottomAxis;
		Chart1->BottomAxis->Title->Caption = pTChartSeries->Title;
		Chart1->BottomAxis->Grid->Visible = False;

		ComboBoxSeries->Items->Add(pTChartSeries->Title);
		pTChartSeries->FillSampleValues(StrToInt(ComboBoxSamples->Text));
	}
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::FormCreate(TObject* Sender)
{
	ComboBoxSamples->Items->Clear();
	ComboBoxSeries->Items->Clear();

	ComboBoxSamples->Items->Add("50");
	ComboBoxSamples->Items->Add("500");
	ComboBoxSamples->Items->Add("5000");
	ComboBoxSamples->Items->Add("20000");
	ComboBoxSamples->ItemIndex = 0;

	Init();

//	const nSeries = 2;
//	for(int i = 0; i < nSeries; ++i)
//	{
//		TChartSeries* pTChartSeries = Chart1->AddSeries(new TLineSeries(Chart1));
//		if(pTChartSeries)
//		{
//			dynamic_cast<TLineSeries*>(pTChartSeries)->Stairs = true;
//
//			pTChartSeries->Title = "Series" + IntToStr(i + 1);
//
//			if((i + 1) % 2 == 0)
//			{
//				pTChartSeries->VertAxis = aLeftAxis;
//				Chart1->LeftAxis->Title->Caption = pTChartSeries->Title;
//				Chart1->LeftAxis->Grid->Visible = False;
//			}
//			else
//			{
//				pTChartSeries->VertAxis = aRightAxis;
//				Chart1->RightAxis->Title->Caption = pTChartSeries->Title;
//				Chart1->RightAxis->Grid->Visible = False;
//			}
//
//			ComboBoxSeries->Items->Add(pTChartSeries->Title);
//			pTChartSeries->FillSampleValues(StrToInt(ComboBoxSamples->Text));
//		}
//	}
//
//	int iSeriesCount = Chart1->SeriesCount();
//
//	for(int i = iSeriesCount; i < (iSeriesCount + nSeries); ++i)
//	{
//		AddVerticalSeries(i);
//	}
//
//	ComboBoxSeries->ItemIndex = 0;
}

//---------------------------------------------------------------------------
void TfoCustomAxis::Init()
{
	Chart1->View3D = false;
	Chart1->View3DWalls = false;

	Chart1->Title->Visible = true;
	Chart1->Title->CustomPosition = true;

	Chart1->Legend->Visible = true;
	Chart1->Legend->Alignment = laBottom;
	Chart1->Legend->CustomPosition = true;

	//Chart1->MarginUnits = muPixels;
	//Chart1->Zoom->Direction = tzdHorizontal;
	ComboBoxSeries->Items->Clear();
	cbShowLegend->Checked = Chart1->Legend->Visible;
	cbShowTitle->Checked = Chart1->Title->Visible;
}
//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::cbActivateSelectedSeriesClick(TObject* Sender)
{
	if(ComboBoxSeries->ItemIndex != -1)
	{
		Chart1->Series[ComboBoxSeries->ItemIndex]->Active = cbActivateSelectedSeries->Checked;
	}
}

//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::cbSeriesOtherSideClick(TObject* Sender)
{
	if(ComboBoxSeries->ItemIndex != -1)
	{
		if(Chart1->Series[ComboBoxSeries->ItemIndex]->CustomVertAxis)
		{
			Chart1->Series[ComboBoxSeries->ItemIndex]->CustomVertAxis->OtherSide = cbSeriesOtherSide->Checked;
		}

		if(Chart1->Series[ComboBoxSeries->ItemIndex]->CustomHorizAxis)
		{
			Chart1->Series[ComboBoxSeries->ItemIndex]->CustomHorizAxis->OtherSide = cbSeriesOtherSide->Checked;
		}
	}
}

//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::ComboBoxSeriesChange(TObject* Sender)
{
	cbActivateSelectedSeries->Checked = Chart1->Series[ComboBoxSeries->ItemIndex]->Active;

	if(Chart1->Series[ComboBoxSeries->ItemIndex]->CustomVertAxis)
	{
		cbSeriesOtherSide->Checked = Chart1->Series[ComboBoxSeries->ItemIndex]->CustomVertAxis->OtherSide;
	}

	if(Chart1->Series[ComboBoxSeries->ItemIndex]->CustomHorizAxis)
	{
		cbSeriesOtherSide->Checked = Chart1->Series[ComboBoxSeries->ItemIndex]->CustomHorizAxis->OtherSide;
	}
}

//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::bFillSampleValuesClick(TObject* Sender)
{
	for(int i = 0; i < Chart1->SeriesCount(); ++i)
	{
		Chart1->Series[i]->FillSampleValues(StrToInt(ComboBoxSamples->Text));
	}
}

//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::bAddLeftCustomSeriesClick(TObject* Sender)
{
	AddVerticalSeries(Chart1->SeriesCount(), false);
}
//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::bAddRightCustomSeriesClick(TObject *Sender)
{
	AddVerticalSeries(Chart1->SeriesCount(), true);
}
//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::bAddBottomCustomSeriesClick(TObject *Sender)
{
	AddHorizontalSeries(Chart1->SeriesCount(), false);
}
//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::bAddTopCustomSeriesClick(TObject *Sender)
{
	AddHorizontalSeries(Chart1->SeriesCount(), true);
}
//---------------------------------------------------------------------------
void TfoCustomAxis::AddHorizontalSeries(int i, bool bOtherSide)
{
	TChartSeries* pTChartSeries = Chart1->AddSeries(new TLineSeries(Chart1));
	if(pTChartSeries)
	{
        dynamic_cast<TLineSeries*>(pTChartSeries)->Stairs = true;
		pTChartSeries->Title = "Series" + IntToStr(i);
		TChartAxis* pTChartAxis = Chart1->CustomAxes->Add();
		if(pTChartAxis)
		{
			pTChartAxis->Horizontal = true;
			Chart1->Series[i]->CustomHorizAxis = pTChartAxis;
			pTChartAxis->OtherSide = bOtherSide;
			pCChartTools->PrepareChartAxis(pTChartAxis);
		}
		ComboBoxSeries->Items->Add(pTChartSeries->Title);
		pTChartSeries->FillSampleValues(StrToInt(ComboBoxSamples->Text));
	}
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::cbShowLegendClick(TObject *Sender)
{
	Chart1->Legend->Visible = cbShowLegend->Checked;
	Chart1->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::bClearClick(TObject *Sender)
{
	Chart1->ClearChart();
	Init();
}
//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::bEditClick(TObject *Sender)
{
	ChartEditor1->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TfoCustomAxis::cbVerticalAxisInOneStackClick(TObject *Sender)
{
	pCChartTools->setVerticalAxisInOneStack(cbVerticalAxisInOneStack->Checked);
	Chart1->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::cbHorizontalAxisInOneStackClick(TObject *Sender)
{
	pCChartTools->setHorizontalAxisInOneStack(cbHorizontalAxisInOneStack->Checked);
	Chart1->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::bAddAllCustomAxisSeriesClick(TObject *Sender)
{
	AddAllCustomAxisSeries(Chart1->SeriesCount(), false);
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::cbShowTitleClick(TObject *Sender)
{
	Chart1->Title->Visible = cbShowTitle->Checked;
	Chart1->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::ChartListBox1ChangeActive(TChartListBox *Sender, TCustomChartSeries *Series)

{
	TChartSeries* pTChartSeries = dynamic_cast<TChartSeries*>(Series);
	if(pTChartSeries)
	{
		if(pCChartTools->IsCustomAxis(pTChartSeries->GetVertAxis))
		{
			if(!pCChartTools->FindFirstActiveSeriesForAxis(Sender->Chart, pTChartSeries->GetVertAxis))
			{
				pTChartSeries->CustomVertAxis->Visible = false;
			}
			else
			{
				pTChartSeries->GetVertAxis->Visible = Series->Active;
			}
		}

		if(pCChartTools->IsCustomAxis(pTChartSeries->GetVertAxis))
		{
			if(!pCChartTools->FindFirstActiveSeriesForAxis(Sender->Chart, pTChartSeries->GetHorizAxis))
			{
				pTChartSeries->GetHorizAxis->Visible = false;
			}
			else
			{
				pTChartSeries->GetHorizAxis->Visible = Series->Active;
			}
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::bMetaClick(TObject *Sender)
{
   foMeta->Image1->Picture->Assign(Chart1->TeeCreateMetafile(false, Rect(0, 0, foMeta->Image1->Width, foMeta->Image1->Height)));
   foMeta->Show();
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::bRefreshClick(TObject *Sender)
{
	//Chart1->Refresh();
	Chart1->Draw();
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::Chart1BeforeDrawChart(TObject *Sender)
{
	TCustomChart* pTCustomChart = dynamic_cast<TCustomChart*>(Sender);
	if(pTCustomChart)
	{
		if(bFirstDraw)
		{
			pCChartTools->PlaceChartObjects(pTCustomChart);
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TfoCustomAxis::Chart1AfterDraw(TObject *Sender)
{
	TCustomChart* pTCustomChart = dynamic_cast<TCustomChart*>(Sender);
	if(pTCustomChart)
	{
		if(cbAutoDraw2x->Checked)
		{
			TNotifyEvent OnAfterDraw = pTCustomChart->OnAfterDraw;
			try
			{
				bFirstDraw = false;
				pTCustomChart->OnAfterDraw = NULL;
				pTCustomChart->Draw();
				pCChartTools->PlaceChartObjects(pTCustomChart);
				pTCustomChart->Draw();
			}
			__finally
			{
                bFirstDraw = true;
				pTCustomChart->OnAfterDraw = OnAfterDraw;
			}
		}
	}
}
//---------------------------------------------------------------------------

