//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Chart.hpp"
#include "TeeEdit.hpp"
#include "TeeGDIPlus.hpp"
#include "TeEngine.hpp"
#include "TeeProcs.hpp"
#include "TeeTools.hpp"
#include <ExtCtrls.hpp>
#include "TeeLegendScrollBar.hpp"
#include "TeeScrollPagerTool.hpp"
#include "TeeSubChart.hpp"
#include "CChartTools.h"
#include "TeeLisB.hpp"
//---------------------------------------------------------------------------
class TfoCustomAxis : public TForm
{
__published:	// IDE-managed Components
	TChart *Chart1;
	TPanel *Panel1;
	TLabel *Label1;
	TLabel *Label2;
	TComboBox *ComboBoxSamples;
	TComboBox *ComboBoxSeries;
	TCheckBox *cbActivateSelectedSeries;
	TCheckBox *cbSeriesOtherSide;
	TButton *bFillSampleValues;
	TButton *bAddLeftCustomSeries;
	TChartEditor *ChartEditor1;
	TButton *bAddBottomCustomSeries;
	TCheckBox *cbShowLegend;
	TButton *bAddLeftSeries;
	TButton *bAddRightSeries;
	TButton *bAddTopSeries;
	TButton *bAddBottomSeries;
	TButton *bClear;
	TButton *bAddRightCustomSeries;
	TButton *bAddTopCustomSeries;
	TButton *bEdit;
	TCheckBox *cbVerticalAxisInOneStack;
	TCheckBox *cbHorizontalAxisInOneStack;
	TButton *bAddAllCustomAxisSeries;
	TChartListBox *ChartListBox1;
	TSplitter *Splitter1;
	TCheckBox *cbShowTitle;
	TButton *bMeta;
	TButton *bRefresh;
	TCheckBox *cbAutoDraw2x;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall cbActivateSelectedSeriesClick(TObject *Sender);
	void __fastcall cbSeriesOtherSideClick(TObject *Sender);
	void __fastcall ComboBoxSeriesChange(TObject *Sender);
	void __fastcall bAddLeftCustomSeriesClick(TObject *Sender);
	void __fastcall bFillSampleValuesClick(TObject *Sender);
	void __fastcall bAddBottomCustomSeriesClick(TObject *Sender);
	void __fastcall cbShowLegendClick(TObject *Sender);
	void __fastcall bAddLeftSeriesClick(TObject *Sender);
	void __fastcall bAddRightSeriesClick(TObject *Sender);
	void __fastcall bAddTopSeriesClick(TObject *Sender);
	void __fastcall bAddBottomSeriesClick(TObject *Sender);
	void __fastcall bClearClick(TObject *Sender);
	void __fastcall bAddRightCustomSeriesClick(TObject *Sender);
	void __fastcall bAddTopCustomSeriesClick(TObject *Sender);
	void __fastcall bEditClick(TObject *Sender);
	void __fastcall cbVerticalAxisInOneStackClick(TObject *Sender);
	void __fastcall cbHorizontalAxisInOneStackClick(TObject *Sender);
	void __fastcall bAddAllCustomAxisSeriesClick(TObject *Sender);
	void __fastcall cbShowTitleClick(TObject *Sender);
	void __fastcall ChartListBox1ChangeActive(TChartListBox *Sender, TCustomChartSeries *Series);
	void __fastcall bMetaClick(TObject *Sender);
	void __fastcall bRefreshClick(TObject *Sender);
	void __fastcall Chart1BeforeDrawChart(TObject *Sender);
	void __fastcall Chart1AfterDraw(TObject *Sender);

private:	// User declarations
	CChartTools* pCChartTools;
	bool bFirstDraw;
	void Init();
	void AddVerticalSeries(int i, bool bOtherSide);
	void AddHorizontalSeries(int i, bool bOtherSide);
	void AddAllCustomAxisSeries(int i, bool bOtherSide);
public:		// User declarations
	__fastcall TfoCustomAxis(TComponent* Owner);
	__fastcall ~TfoCustomAxis();
};
//---------------------------------------------------------------------------
extern PACKAGE TfoCustomAxis *foCustomAxis;
//---------------------------------------------------------------------------
#endif
